<?php
/*
 * @version $Id: HEADER 15930 2011-10-30 15:47:55Z tsmr $
 -------------------------------------------------------------------------
 Metademands plugin for GLPI
 Copyright (C) 2018-2022 by the Metademands Development Team.

 https://github.com/InfotelGLPI/metademands
 -------------------------------------------------------------------------

 LICENSE

 This file is part of Metademands.

 Metademands is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 Metademands is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Metademands. If not, see <http://www.gnu.org/licenses/>.
 --------------------------------------------------------------------------
 */

include ('../../../inc/includes.php');
Session::checkLoginUser();

if (Plugin::isPluginActive("metademands")) {

   Session::checkRight("config", UPDATE);

   $config = new PluginMetademandsConfig();

   if (isset($_POST["update_config"])) {
      $config_data = PluginMetademandsConfig::getInstance();
      if (empty($config_data)) {
         $config->add($_POST);
      } else {
         $_POST['id'] = 1;
         $config->update($_POST);
      }
      Html::back();

   } else {
      Html::header(__('Setup'), '', "helpdesk", "pluginmetademandsmenu", "config");
      $config->display($_GET);
      Html::footer();
   }

} else {
   Html::header(__('Setup'), '', "helpdesk", "pluginmetademandsmenu", "config");
   echo "<div class='alert alert-important alert-warning d-flex'>";
   echo "<b>".__('Please activate the plugin', 'metademands')."</b></div>";
   Html::footer();
}
